%% Estimaattien herkkyyden kohinalle net ajamalla skriptin useaan kertaan
clf
load las07t5data.mat
% Listn ulostuloon mittauskohinaa
e = randn(length(y), 1) * norm(y)/length(y) * 0.2;
e = filter([0.2 0.6 0.2], 1, e); % alipstetn kohina
y = y+e;

useFFT = false;
% Laskut voidaan suorittaa joko MATLABin FFT-funktiolla
% tai laskemalla sistulot silmukoissa

useHanning = true;
% Ilman ikkunointia A ja B tuottavat saman tuloksen.
% Ikkunoimattoman laskennan ulos on hyvin herkk kohinalle: 
% Kokeile esim. lyhent inputsignaaleja yhden nytteen verran 
% vaihtamalla allaoleva ehdon paikalle  if true
if false
    u = u(1:end-1);
    y = y(1:end-1);
end;

%% A: Lasketaan ensin signaalien Fourier-muunnokset
clear w US2 YS2 GS2 uu yy omega
u=u-mean(u);
y=y-mean(y);

delta = 2*pi/length(y); %0.1;
omega = delta:delta:(pi-delta);
if useHanning,
    w = hanning(length(u));
else
    w = ones(size(u));
end;

if useFFT,
    US2 = fft(w.*u);
    US2 = US2(2:floor(length(u)/2));
    YS2 = fft(w.*y);
    YS2 = YS2(2:floor(length(u)/2));
else
    US2 = zeros(1, length(omega));
    YS2 = zeros(1, length(omega));
    yy = (w.*y)';
    uu = (w.*u)';
    for ii = 1:length(omega)
        YS2(ii) = sum(yy.*exp(-j*omega(ii)*(0:length(y)-1)));
        US2(ii) = sum(uu.*exp(-j*omega(ii)*(0:length(u)-1)));
    end
end;

GS2 = YS2./US2;
% Taajuusvaste
subplot(3,1,1);
loglog(omega',abs(GS2),'r.-');
hold on;
% Vaihesiirto
subplot(3,1,2);
semilogx(omega',180*angle(GS2)/pi,'r.-');
hold on;

%% B
clear Ru Ry Ryu w N Phiu Phiy Phiyu gamma G

% lasketaan ikkunafunktio ja autokovarianssit
Ru  = xcorr(u,u);
Ry  = xcorr(y,y);
Ryu = xcorr(u,y);
if useHanning,
    % Kokeile muuttaa ikkunan leveytt vaihtamalla 
    % alle esim length(R)/2
    N = round(length(Ru)/2);
    windowLength = N;
    w = hanning(windowLength);
    w = [zeros(floor((length(Ru)-length(w))/2),1); ...
       hanning(length(w)); ...
       zeros(ceil((length(Ru)-length(w))/2),1);];
else
    w = ones(length(Ru), 1);
end;

% sitten varsinainen tasoitus
Phiu=zeros(length(omega),1);
Phiy=Phiu;
Phiyu=Phiu;

if useFFT,
    Phiu = fft(w.*Ru, length(Ru)+1);
    % Otetaan joka toinen alkio fft:st, koska risti- ja
    % autokorrelaatiovektorien pituus = 
    % 2*datavektorin pituus -1.
    % Tllin mys fft tulee laskettua suuremmalla
    % tarkuudella kuin A kohdassa.
    Phiu = Phiu(3:2:floor(length(Ru)/2)); 

    Phiy = fft(w.*Ry, length(Ry)+1);
    Phiy = Phiy(3:2:floor(length(Ry)/2)); 
    
    Phiyu = fft(w.*Ryu, length(Ryu)+1);
    Phiyu = Phiyu(3:2:floor(length(Ryu)/2));
else
    gamma=length(u)-1;
    for i=1:length(omega)
        % Tss lasketaan periodogrammi suoraan samoilla taajuuksilla 
        % kuin A-kohdassa
        Phiu(i)=0;
        Phiyu(i)=0;
        for k=-gamma:gamma
            Phiu(i)=Phiu(i)+w(k+gamma+1)*Ru(k+(length(Ru)+1)/2)*exp(-j*omega(i)*k);
            Phiy(i)=Phiy(i)+w(k+gamma+1)*Ry(k+(length(Ry)+1)/2)*exp(-j*omega(i)*k);
            Phiyu(i)=Phiyu(i)+w(k+gamma+1)*Ryu(k+(length(Ryu)+1)/2)*exp(-j*omega(i)*k);
        end
    end
end;

G = Phiyu./Phiu;

% Taajuusvaste
subplot(3,1,1);
loglog(omega',abs(G));

% Vaihesiiirto
subplot(3,1,2);
semilogx(omega',-angle(G)*180/pi);

% Kohinan spektri
subplot(3,1,3);
Phiv = Phiy - (Phiyu.*conj(Phiyu))./Phiu;
loglog(omega',abs(Phiv));
hold on;

%% Plotataan viel todellinen siirtofunktio (ks LH7T5)
clear hd w a 

hd = dfilt.df1(1,[1 1 0.1]);
[h,w] = freqz(hd);
subplot(3,1,1);
% Taajuusvaste
a = axis;
loglog(w',abs(h), 'k:');
axis(a);
legend('EFTE', 'Blackman-Tukey', 'todellinen sf', 'location', 'NorthWest')
title('Taajuusvaste')
hold off;

subplot(3,1,2);
% Vaihesiirto
a = axis;
semilogx(w',-angle(h)*180/pi, 'k:');
axis(a);
legend('EFTE', 'Blackman-Tukey', 'todellinen sf', 'location', 'SouthWest')
title('Vaihesiiirto')
hold off;

subplot(3,1,3)
title('Kohinan spektri')
hold off;
